function [max_c,q,cq]=AtReSelFFT(Re,M,pha,Di,Dic,Dis,option);
%
%AtReSelFFT Atom Re-Selection via FFT
%
%Inputs 
%      Re  Residual  
%      M   number of elements in the dictionary
%      pha phases for the inne producnt via FFT
%      Di  indices of the subdictionary Di=Dic U Dis
%      Dic indices in Cos dictionry
%      Dis indices in Sin dictionry
%      options (1, 2,  3 or 4 to set dictionary type)
%
%Outputs
%      q      sected index
%      cq     MP coefficinet for the index q
%      max_c  max(abs(coeficients))
%
L= length(Re);
%
switch option  
%
    case 1 
      ccp(1:M)=0;
      cc=fft(Re,M)*sqrt(1/L);
      ccp(Di)=cc(Di);
      [max_c,q]=max(abs(ccp));
      cq=ccp(q);
    case 2
      cf=fft(Re,2*M);
      cc=real(pha(1,:).*cf(1:M));
%     
      ccp(1:M)=0;
      ccp(Di)=cc(Di);
%
      [max_c,q]=max(abs(ccp));
%
      cq=ccp(q);
    case 3
      cf=fft(Re,2*M);
      cf(1)=[];
      cc=-imag(pha(1,:).*cf(1:M));
%     
      ccp(1:M)=0;
      ccp(Di)=cc(Di);

      [max_c,q]=max(abs(ccp));
%
      cq=ccp(q);
    case 4
     N=M;
     M=N/2;
     cf=fft(Re,2*M);
     cff=cf(1:M);
     c1=real(pha(1,:).*cff);
     cff(1)=[];
     cff(M)=cf(M+1);
     c2=-imag(pha(2,:).*cff);
%     
     c1p(1:M)=0;
     c1p(Dic)=c1(Dic);
     c2p(1:M)=0;
     c2p(Dis)=c2(Dis);
% 
     [max_c1 q1]= max(abs(c1p));
     [max_c2 q2]= max(abs(c2p));
% 
     if max_c1 >= max_c2
       max_c = max_c1;
        q =q1;
       cq=c1p(q1);
      else
      max_c = max_c2;
      cq=c2p(q2);
       q=q2+N/2;
end
   otherwise
   disp('unknown option');
end
