function [max_c,q,cq]=AtSelFFT(Re,M,pha,option);

%Input: Re residual
%       M    number of elements in the dictionry
%       pha  phases to use FFT for inner products with Trg dictionries
%       option for the dictionry to be used

%Output: max_c maximum correlation in absolute value
%        q     selected index
%        cq    MP coefficient for the selected atom       

L= length(Re);

switch option 
%
    case 1 
      cc=fft(Re,M)*sqrt(1/L);
      [max_c,q]=max(abs(cc));
      cq=cc(q);
    case 2
      cf=fft(Re,2*M);
      cc=real(pha(1,:).*cf(1:M));
%
      [max_c,q]=max(abs(cc));
%
      cq=cc(q);
    case 3
      cf=fft(Re,2*M);
      cf(1)=[];
      cc=-imag(pha(1,:).*cf(1:M));
%
      [max_c,q]=max(abs(cc));
%
      cq=cc(q);
    case 4
     N=M;
     M=N/2;
     cf=fft(Re,2*M);
     cff=cf(1:M);
     c1=real(pha(1,:).*cff);
     cff(1)=[];
     cff(M)=cf(M+1);
     c2=-imag(pha(2,:).*cff);
%
     [max_c1 q1]= max(abs(c1));
     [max_c2 q2]= max(abs(c2));
% 
     if max_c1 >= max_c2
       max_c = max_c1;
        q =q1;
       cq=c1(q1);
      else
      max_c = max_c2;
      cq=c2(q2);
       q=q2+N/2;
end
   otherwise
   disp('unknown option');
end
