%This script tests the routine SPMPTrgFFT. 
%The signal is the flute clip (to change it change
%'wavfile' below)
%By default the partition is of length bw=4096 (to change it 
%change 'bw' below)
%The approximation is up to SNR=35dB (to change it 
%change 'pss' below)
%The dictionary is a mixed Cos U Sin dictionary, icase=4 (to change it change 'icase' below)
%The redundancy is a=4 (to change it change 'a' below).

%=====================================================
%Note: to deactivate the self-projections change lstep 
%to lstep=-1 below and the routine will run MPTrgFFT
%Note lstep=-1 runs faster an still gives good 
%sparsity results. It is remomended to first set 
%lstep=-1 when trying a new signal and lstep=1 for 
%further improvements.
%=====================================================
%
wavfile='flute_clip.wav'
[signal,fs]=audioread(wavfile); %read the music file
%
%settings
%
bw=4096;% length of the partition unit
pss=35  %target SNR
icase=4 %dictionary type
a=4  %redundancy
lstep=1; %change to -1 to cancel self-projections
%
%end settings

[s1,s2]=size(signal);
if s1< s2; signal=signal';end
f=signal';
%
%
tic;
L=bw
N=bw*a
%
[nordt]=NormTrgDict(bw,a,icase); %get the normalization factors
%
clear eex
eex=[]; %phase factors for  inner products via FFT
M=N; 
if icase==4 M=N/2;end  %cosine \cup sin dictionary
k=1:M;
if icase==2 | icase ==4 % icase 2 cosine dictionary
eex(1,:)=exp(-pi*1i*(k-1)/(2*M))./nordt(1,:);
end
if icase==3 %sine dictionary
eex(1,:)=exp(-pi*1i*(k)/(2*M))./nordt(1,:);;
end
if icase==4
eex(2,:)=exp(-pi*1i*(k)/(2*M))./nordt(2,:);;
end

%
%
s=floor(numel(f)/bw);
mf=f(1:s*bw);%resize the signal to be divisible by bw
Nx=numel(mf);
Nframe=Nx/bw; %number of frames
t0=1;
cmf=cell(Nframe,1);
%
for j=1:Nframe;
t=t0:t0+bw-1;
t0=t0+bw;
cmf{j}=mf(t);
end
%======end the segmentation each cmf is a cell with a frame or size bw===
NBX=Nframe;
delta=1;
%
indx=[]; %do not touch 
%
No=bw;
mfc=cell(Nframe,1);
c=cell(Nframe,1);
nCoe=0;
zero_frame=0;
Max=20000; % Max number of iterations
Maxp=20000;% Max number of iterations for the projections
toln=5e-4; %tolerance error for the projection
%toln=1e-8; %tolerance error for the projection
LN=[L N];
%
%=============Start the approxiamtion of each block=========
%
clear c0 D0 Di0 beta0 c0 Q0 h cbeta cQ cD c cDi1 kap mk cf cf2  cfs 
tic;
cf=zeros(N,Nframe);
for j=1:Nframe;
tol=sqrt(norm(cmf{j})^2/(10^(pss/10)));
if (norm(cmf{j})^2)*delta>1e-5%avoids to try and approximate a zero block 

[h{j}, cDi1{j},c{j},kap{j}]= SPMPTrgFFT(cmf{j},LN,tol,No,toln,lstep,Max,Maxp,indx,eex,icase);
%======== save the coefficients and indices and approximated block 
k0=numel(cDi1{j});
cc{j}=c{j}(cDi1{j});
%c{j}=cc{j}';
if lstep ~=-1 
mk(j)=mean(kap{j});
end
nCoe = nCoe + k0; %number of coefficients in the frames
else
nCoe = nCoe + 1;     %counts 1 coefficient per zero frame )
num_zero_blocks=zero_frame+1 %numbers of zero frame
h{j}=zeros(bw,1)';
c{j}=zeros(1,1);
%cDi1{j}=zeros(1,1);
cDi1{j}=1;
end
cf(cDi1{j},j)=cc{j}';
end
toc
for i=1:N/2;
cfs(i,:)=cf(i+N/2,:);
cf2(i,:)=cfs(i,:).^2+cf(i,:).^2;
end
%
%=====================================================================
fa=[];
for i=1:Nframe
%h{i}=h{i}';
fa=[fa h{i}];%assemble the whole signal from the partition
end
fprintf('===============================================\n')
;
%
 fprintf(' Sparsity Ratio SR.\n');
%
SR= numel(mf)/nCoe% Sparsity ratio
nCoe %numer of atoms
%
 fprintf(' Approximation quality SNR.\n');
%
SNR= CalcSNR(mf,fa)
fprintf('===============================================\n')
MSE=norm(fa-mf)^2/numel(mf) % MSE of the approximation
mean_noise=mean(fa-mf)
var_noise=var(fa-mf)
if lstep ~= -1
mean_projection_times=mean(mk)
end
