function NewAtom=TrgAt(q,tt,a,icase)
%
%Generation of  a trigonometric atom, given the index and 
%the case

%Input
%      q  index of the requiered the atom
%      tt vector with evaluation points
%      N  number of elements in the dictionary
%      a is the redundancy or redundancy/2 for case 4
%      icase for dictionry type 1 for exponential 2 Cosine  3 Sine  4 Mixed Cos/Sine

%Output 
%      NewAtom  atom at the evaluation points tt
%
L=numel(tt);
N=a*L; %number of elements in the dictionary
switch icase
case 1
NewAtom=1/sqrt(L)*exp(-2*pi*1i*(tt-1).'*((q-1)/(N)));
NewAtom=NewAtom/norm(NewAtom);
case 2
NewAtom=cos(pi*(2*tt-1)'*((q-1)/(2*N)));
NewAtom=NewAtom/norm(NewAtom);
case 3
 NewAtom=sin(pi*(2*tt-1)'*(q/(2*N)) );
 NewAtom=NewAtom/norm(NewAtom);
case 4
   if q <= N
  NewAtom=cos(pi*(2*tt-1)'*((q-1)/(2*N)));
  NewAtom=NewAtom/norm(NewAtom);
   else
  q=q-N;
  NewAtom=sin(pi*(2*tt-1)'*(q/(2*N)));
  NewAtom=NewAtom/norm(NewAtom);
  end
end
